Imports System.Drawing.Design
Imports System.Windows.Forms.Design

Friend Class EmployeeEditor
    Inherits UITypeEditor

    ' We display a modal dialog.
    Public Overloads Overrides Function GetEditStyle(ByVal context As System.ComponentModel.ITypeDescriptorContext) As System.Drawing.Design.UITypeEditorEditStyle
        Return UITypeEditorEditStyle.Modal
    End Function

    ' Edit the value.
    Public Overloads Overrides Function EditValue(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object
        ' Get an IWindowsFormsEditorService.
        Dim editor_service As IWindowsFormsEditorService = _
            CType( _
                provider.GetService( _
                    GetType(IWindowsFormsEditorService)), _
                IWindowsFormsEditorService)
        If editor_service Is Nothing Then Return Nothing

        ' Display the input dialog.
        Dim first_name As String
        Dim last_name As String
        If value Is Nothing Then
            first_name = ""
            last_name = ""
        Else
            Dim the_setting As Employee = CType(value, Employee)
            first_name = the_setting.FirstName
            last_name = the_setting.LastName
        End If
        Dim dlg As New frmEmployeeEditor
        dlg.txtFirstName.Text = first_name
        dlg.txtLastName.Text = last_name

        ' Display the editor form.
        If editor_service.ShowDialog(dlg) = DialogResult.OK Then
            ' The user clicked OK. Use the new value.
            first_name = dlg.txtFirstName.Text.Trim
            last_name = dlg.txtLastName.Text.Trim
            If (first_name.Length = 0) And (last_name.Length = 0) Then
                value = Nothing
            Else
                value = New Employee(first_name, last_name)
            End If
        End If

        ' Return the value.
        Return value
    End Function
End Class
